//
// motor.c : n݌v H8/36064 DC[^p֐
//

// @@Ӂ@
// VstoneА}CR{[hiVS-WRC003j́wVS-WRC003 eNjJ}jAxɂ́A
// P60[qiFTIOA0jPWMo͂pāACN1/M1RlN^DC[^]łƏĂ邪A
// ۂɂ́AFTIOA0PWMo͂̋@\LĂȂB
// (uH8/36064 O[vn[hEFA}jA w12. ^C}Z@12.2 o͒[qxvQ)
// ̂߁A{DC[^֘A֐Cuł́AP60[qiFTIOA0jACN1/M1RlN^舵ȂB


#include <machine.h>
#include "iodefine.h"
#include "motor.h"

void MotorInit(char port)
{
	/* ]EPWM̃|[g̐ݒ */
	switch (port) {
		case 0:	// ]FP32, P33   PWMFP61
			IO.PCR3 |= 0x0C;	// P32, P33o͂ɐݒ
			IO.PDR3.BIT.B2 = 0;	// P32̏l0ɐݒ
			IO.PDR3.BIT.B3 = 0;	// P33̏l0ɐݒ
			IO.PCR6 |= 0x02;	// P61o̓|[gɂ
			break;
			
		case 1:	// ]FP70        PWMFP63
			IO.PCR7 |= 0x01;	// P70o͂ɐݒ
			IO.PDR7.BIT.B0 = 0;	// P70̏l0ɐݒ
			IO.PCR6 |= 0x08;	// P63o̓|[gɂ
			break;

		default:
			break;
	}

	/* ^C}Z0̐ݒ */
	set_imask_ccr(1);		// ^C}̐ݒ̑Oɂ͂
	TZ0.TCR.BIT.TPSC = 2;	// [010] /4ŃJEg

	switch (port) {
		case 0:	// ]FP32, P33   PWMFP61
			TZ.TPMR.BIT.PWMB0 = 1;	// FTIOB0PWMo͂ɐݒ
			TZ.TOER.BIT.EB0 = 0;	// P61/FTIOB0^C}o͂ƂĎgp
			TZ.TOCR.BIT.TOB0 = 1;	// FTIOB0̏o͂1ɃZbg
			TZ0.POCR.BIT.POLB = 0;	// PWMo̓xnCANeBu
			TZ0.GRB = 0;			// FTIOB0̃f[eB0
			break;
			
		case 1:	// ]FP70        PWMFP63
			TZ.TPMR.BIT.PWMD0 = 1;	// FTIOD0PWMo͂ɐݒ
			TZ.TOER.BIT.ED0 = 0;	// P63/FTIOD0^C}o͂ƂĎgp
			TZ.TOCR.BIT.TOD0 = 1;	// FTIOD0̏o͂1ɃZbg
			TZ0.POCR.BIT.POLB = 0;	// PWMo̓xnCANeBu
			TZ0.GRD = 0;			// FTIOB0̃f[eB0
			break;

		default:
			break;
	}
	
	TZ.TSTR.BIT.STR0 = 1;	// JEgX^[g
	set_imask_ccr(0);		// ^C}ݒ肵I炱
}



void Motor(char port, char dir, unsigned int duty)
{
	switch (port) {
		case 0:	// ]FP32, P33   PWMFP61
			if (dir == 0) {				/* Oi */
				IO.PDR3.BIT.B2 = 1;		// P32o͒l = 1
				IO.PDR3.BIT.B3 = 0;		// P33o͒l = 0
			} else {					/* i */
				IO.PDR3.BIT.B2 = 0;		// P32o͒l = 0
				IO.PDR3.BIT.B3 = 1;		// P33o͒l = 1
			}

			TZ0.GRB = duty;				// GRBɃRyAlݒ
			break;
			
		case 1:	// ]FP70        PWMFP63
			if (dir == 0) {				/* Oi */
				IO.PDR7.BIT.B0 = 0;		// P70o͒l = 0
			} else {					/* i */
				IO.PDR7.BIT.B0 = 1;		// P70o͒l = 1
			}

			TZ0.GRD = duty;			// GRDɃRyAlݒ
			break;

		default:
			break;
	}
}